package refactoring;

public class Movie {
    public static final int CHILDRENS = 2;
    public static final int REGULAR = 0;
    public static final int NEW_RELEASE = 1;

    private String title;
    private Price price;

    public Movie(String title, int priceCode) {
        this.title = title;
        setPriceCode(priceCode);
    }

    public int getPriceCode() {
        return price.getPriceCode();
    }

    public void setPriceCode(int newPriceCode) {
        switch(newPriceCode) {
        case CHILDRENS:
        	price = new ChildrenPrice();
        	break;
        case REGULAR:
        	price = new RegularPrice();
        	break;
        case NEW_RELEASE:
        	price = new NewReleasePrice();
        	break;
        }
    }

    public String getTitle() {
        return title;
    }
    
	public double getCharge(int daysRented) {
		return price.getCharge(daysRented);
	}
	
    public int getFrequentRenterPoints(int daysRented) {
        // Add bonus for a two day new release rental
        if ((getPriceCode() == Movie.NEW_RELEASE) && daysRented > 1) {
            return 2;
        } else {
        	return 1;
        }
    }
}