package example.stack;

import org.junit.Assert;
import org.junit.Test;

public class SimpleStackTest {

    @Test
    public void testNewStackIsEmpty() {
        SimpleStack stack = new SimpleStack();
        Assert.assertTrue("New stack should be empty!",true == stack.isEmpty());
    } 

    @Test
    public void testNewStackPush() {
        SimpleStack stack = new SimpleStack();
        int item = 1;
        stack.push(item);
        Assert.assertFalse("Stack should not be empty after an item has been pushed!", stack.isEmpty());
    }

    @Test
    public void testEmptyStackPop() {
        SimpleStack stack = new SimpleStack();
        try {
        	@SuppressWarnings("unused")
			int topItem = stack.pop();
            Assert.fail("IllegalStateException expected");
        } catch (java.lang.IllegalStateException e) {
            // Expected
        }
    }

    @Test
    public void testStackPop() {
        SimpleStack stack = new SimpleStack();
        int item = 10;
        stack.push(item);
        int topItem = stack.pop();
        Assert.assertEquals("Popped item was expected to be 10.", item, topItem);
    }
    
    @Test
    public void testStackPushTwice() {
        SimpleStack stack = new SimpleStack();
        int item = 1;
        stack.push(item);
        item = 2;
        stack.push(item);
        Assert.assertFalse("New stack should not be empty after an item has been pushed!", stack.isEmpty());
    }

    @Test
    public void testStackPopTwice() {
        SimpleStack stack = new SimpleStack();
        int item1 = 1;
        stack.push(item1);
        int item2 = 2;
        stack.push(item2);
        int topItem = stack.pop();
        Assert.assertEquals("Popped item was expected to be 2.", item2, topItem);
        topItem = stack.pop();
        
        Assert.assertEquals("Popped item was expected to be 1.", item1, topItem);
        Assert.assertTrue("Stack should be empty after all items has been pushed!", stack.isEmpty());
    }    
}
/*
    @Test
    public void testNewStackIsEmpty() {
        SimpleStack stack = new SimpleStack();
        Assert.assertTrue("New stack should be empty!",true == stack.isEmpty());
    } 
  
    @Test
    public void testNewStackPush() {
        SimpleStack stack = new SimpleStack();
        int item = 1;
        stack.push(item);
        Assert.assertFalse("Stack should not be empty after an item has been pushed!", stack.isEmpty());
    }

    @Test
    public void testEmptyStackPop() {
        int topItem = 0;
        SimpleStack stack = new SimpleStack();
        try {
            topItem = stack.pop();
            Assert.fail("IllegalStateException expected");
        } catch (java.lang.IllegalStateException e) {
            // Expected
        }
    }
    
    @Test
    public void testStackPop() {
        SimpleStack stack = new SimpleStack();
        int item = 1;
        stack.push(item);
        int topItem = stack.pop();
        Assert.assertEquals("Popped item was expected to be 1.", item, topItem);
    }
    
    @Test
    public void testStackPushTwice() {
        SimpleStack stack = new SimpleStack();
        int item = 1;
        stack.push(item);
        item = 2;
        stack.push(item);
        Assert.assertFalse("New stack should not be empty after an item has been pushed!", stack.isEmpty());
    }
    @Test
    public void testStackPopTwice() {
        SimpleStack stack = new SimpleStack();
        int item1 = 1;
        stack.push(item1);
        int item2 = 2;
        stack.push(item2);
        int topItem = stack.pop();
        Assert.assertEquals("Popped item was expected to be 2.", item2, topItem);
        topItem = stack.pop();
        
        Assert.assertEquals("Popped item was expected to be 1.", item1, topItem);
        Assert.assertTrue("Stack should be empty after all items has been pushed!", stack.isEmpty());
    }    

    @Test
    public void testEmptyStackTop() {
        SimpleStack stack = new SimpleStack();
        int top = 0;
        try {
            top = stack.top();
            Assert.fail("IllegalStateException expected");
        } catch (java.lang.IllegalStateException e) {
            // Expected
        }
    }

    @Test
    public void testStackTopTwice() {
        SimpleStack stack = new SimpleStack();
        int item1 = 1;
        stack.push(item1);
        int topItem = stack.top();
        Assert.assertEquals("Top item was expected to be 1.", item1, topItem);
        topItem = stack.top();
        
        Assert.assertEquals("Top item was expected to be 1.", item1, topItem);
        Assert.assertFalse("Stack should not be empty after stack hass beeb topped!", stack.isEmpty());
    }
*/
